//package com.odhen.taa;
//
//import android.app.Activity;
//import android.content.Context;
//import android.os.Bundle;
//import android.util.Log;
//import android.webkit.JavascriptInterface;
//import android.webkit.WebView;
//import android.widget.Toast;
//
//import org.json.JSONException;
//import org.json.JSONObject;
//
//import br.com.softwareexpress.sitef.android.CliSiTef;
//import br.com.softwareexpress.sitef.android.CliSiTefI;
//import br.com.softwareexpress.sitef.android.ICliSiTefListener;
//
//// public class SitefIntegration extends Activity implements ICliSiTefListener
//public class SitefIntegration2 extends Activity implements ICliSiTefListener {
//    Context mContext;
//    private String TAG = "|SitefIntegration| ";
//    private CliSiTef sitef;
//    private SitefIntegration2 me;
//    private WebView webView;
//
//    protected PaymentData paymentData;
//    private JSONObject dataObject = null;
//    private JSONObject returnObject = null;
//    private String givenCommands = "";
//
//    /** Instantiate the interface and set the context */
//    SitefIntegration2(Context c) {
//        mContext = c;
//    }
//
//    @JavascriptInterface
//    public void showToast(String message) {
//        Toast.makeText(mContext, message, Toast.LENGTH_SHORT).show();
//    }
//
//    @Override
//    protected void onCreate(Bundle savedInstanceState) {
//        super.onCreate(savedInstanceState);
//        setContentView(R.layout.activity_main);
//        webView = (WebView) findViewById(R.id.taaWebView);
//    }
//
//    private JSONObject jsonEncode(String data) throws JSONException {
//        return new JSONObject(data);
//    }
//
//    private void initSitefInstanceAndMe() {
//        Log.d(TAG, "----------     INICIA INSTANCIA DA SITEF     ----------");
//        sitef = new CliSiTef(mContext.getApplicationContext());
//        sitef.setActivity((Activity) mContext);
//        me = this;
//    }
//
//    private void closeSitefInstanceAndMe() {
//        Log.d(TAG, "----------     INICIA INSTANCIA DA SITEF     ----------");
//        if(sitef != null){
//            sitef.setActivity(null);
//        }
//        sitef = null;
//        me = null;
//    }
//
//    private boolean identifyCommand(int command, int minLength, int maxLength) throws JSONException {
//        String buffer = sitef.getBuffer();
//        returnObject.put("message", buffer);
//        int tipoCampo = sitef.getFieldId();
//        Log.d(TAG, "Buffer: " + buffer);
//
//        givenCommands += command + ", ";
//
//        if(buffer.contains("Insira") || buffer.contains("passe")) {
//            webView.loadUrl("javascript:showCancelButton()");
//        }
//
//        switch (command) {
//            case CliSiTef.CMD_SHOW_QRCODE_FIELD:
//                switch (tipoCampo) {
//                    case 584:
//                        webView.loadUrl("javascript:showQrCode('"+buffer+"')");
//                        break;
//                }
//                return true;
//            case CliSiTef.CMD_REMOVE_QRCODE_FIELD:
//                webView.loadUrl("javascript:hideQrCode()");
//                return true;
//            case CliSiTefI.CMD_TITULO_MENU:
//                webView.loadUrl("javascript:setLabel('" + buffer + "')");
//                return true;
//            case CliSiTefI.CMD_REMOVE_CABECALHO:
//                webView.loadUrl("javascript:setLabel('SiTEF')");
//                return true;
//            case CliSiTefI.CMD_MENSAGEM:
//                webView.loadUrl("javascript:setMessage('" + buffer + "')");
//                return true;
//            case CliSiTefI.CMD_REMOVE_MENSAGEM:
//                webView.loadUrl("javascript:setMessage('')");
//                return true;
//            case CliSiTefI.CMD_RETORNO_VALOR:
//                switch (tipoCampo) {
//                    case 105:
//                        dataObject.put("transactionDate", buffer);
//                        break;
//                    case 121:
//                        dataObject.put("customerReceipt", buffer);
//                        break;
//                    case 122:
//                        dataObject.put("merchantReceipt", buffer);
//                        break;
//                    case 132:
//                        dataObject.put("cardBrandName", buffer);
//                        break;
//                    case 134:
//                        dataObject.put("uniqueSequentialNumber", buffer);
//                        break;
//                    case 136:
//                        dataObject.put("binCard", buffer);
//                        webView.loadUrl("javascript:hideUserInterfaces()");
//                        break;
//                    case 1190:
//                        dataObject.put("lastNumbersCard", buffer);
//                        break;
//                    default:
//                        break;
//                }
//
//                return true;
//            case CliSiTefI.CMD_PERGUNTA_SE_INTERROMPE:
//                sitef.setBuffer("0");
//                return true;
//            case CliSiTefI.CMD_CONFIRMA_CANCELA:
//                sitef.setBuffer("0");
//                return true;
//            case CliSiTefI.CMD_SELECIONA_MENU:
//                validaTipoCampo(tipoCampo, maxLength, minLength, buffer);
//                return true;
//            case CliSiTefI.CMD_OBTEM_VALOR:
//                validaTipoCampo(tipoCampo, maxLength, minLength, buffer);
//                return true;
//            case CliSiTefI.CMD_OBTEM_QUALQUER_TECLA:
//            case CliSiTefI.CMD_OBTEM_CAMPO:
//                validaTipoCampo(tipoCampo, maxLength, minLength, buffer);
//                return true;
//            case CliSiTefI.CMD_MENSAGEM_OPERADOR:
//            case CliSiTefI.CMD_MENSAGEM_CLIENTE:
//            case CliSiTefI.CMD_REMOVE_MENSAGEM_OPERADOR:
//            case CliSiTefI.CMD_REMOVE_MENSAGEM_CLIENTE:
//            case CliSiTefI.CMD_REMOVE_TITULO_MENU:
//            default:
//                break;
//        }
//        return true;
//    }
//
//    private boolean validaTipoCampo(int tipoCampo, int maxLength, int minLength, String buffer) {
//        if(tipoCampo == 146) {
//            sitef.setBuffer(paymentData.getPaymentValue());
//        } else if(tipoCampo == 500){
//            sitef.setBuffer("123456");
//        } else if(tipoCampo == 504 || tipoCampo == 130) {
//            sitef.setBuffer("0");
//        } else if(tipoCampo == 515) {
//            sitef.setBuffer(paymentData.getPaymentDate());
//        } else if(tipoCampo == 516) {
//            String paymentNSU = paymentData.getPaymentNSU();
//
//            while(paymentNSU.length() > maxLength) { paymentNSU = paymentNSU.substring(1); }
//
//            sitef.setBuffer(paymentNSU);
//        } else if(tipoCampo == -1) {
//                    /* Validação para verificar se o tipoCampo -1 está sendo acessado para trazer as
//                     carteiras digitais que vem no formato 1:(nome da carteira digital);2:(nome da carteira);etc....*/
//            if (buffer.indexOf("1:") != -1) {
//                webView.loadUrl("javascript:showMenuDigitalCard('" + buffer + "')");
//                return false;
//            } else {
//                webView.loadUrl("javascript:hideUserInterfaces()");
//            }
//        } else {
//            webView.loadUrl("javascript:promptCommand('" + buffer + "', " + minLength + ", " + maxLength + ", " + tipoCampo + ")");
//            return false;
//        }
//        return false;
//    }
//
//    @Override
//    public void onData(int currentStage, int command, int fieldId, int minLength, int maxLength, byte [] input) {
//        Log.d(TAG, "onData - estagio atual: "  + currentStage + ", comando: " + command + ", tipoCampo: " + fieldId + ", continua?");
//        try {
//            boolean hasToContinue = me.identifyCommand(command, minLength, maxLength);
//
//            Log.d(TAG, "onData - estagio atual: "  + currentStage + ", comando: " + command + ", tipoCampo: " + fieldId + ", continua? " + hasToContinue + ".");
//            if(hasToContinue) {
//                sitef.continueTransaction(sitef.getBuffer());
//            }
//
//        } catch (Exception e) {
//            Log.d(TAG, e.getMessage().toString());
//            sitef.abortTransaction(0);
//        }
//    }
//
//    @Override
//    public void onTransactionResult(int currentStage, int resultCode) {
//        Log.d(TAG, "estagio atual: " + currentStage + ", resultado: " + resultCode);
//    }
//
//    @JavascriptInterface
//    public String configure (String data) {
//        String retorno = null;
//        try {
//            dataObject = jsonEncode(data);
//            this.paymentData = new PaymentData(dataObject);
//
//            returnObject = new JSONObject();
//            returnObject.put("error", true);
//            returnObject.put("message", "");
//            returnObject.put("errorCode", null);
//
//            initSitefInstanceAndMe();
//
//            Log.d(TAG, "----------     INÍCIO CONFIGURAÇÃO PARA TRANSAÇÃO     ----------");
//            int sts = sitef.configure(paymentData.getPaymentIp(), paymentData.getPaymentStore(), paymentData.getPaymentTerminal(), paymentData.getParams());
//
//            if(sts == 0) {
//                retorno = "Configura - OK";
//                Log.d(TAG, retorno);
//                return TAG + retorno;
//            } else {
//                retorno = new ErrorMessages().getErrorMessageFromStatus(sts);
//                Log.d(TAG, "Configura - ERRO: " + retorno);
//                return TAG + "Configura - ERRO: " + retorno;
//            }
//
//        }catch (JSONException err){
//            Log.d(TAG + "ConfigureError", err.toString());
//            return err.toString();
//        }
//    }
//
//    @JavascriptInterface
//    public String startTransaction (String data) {
//        String retorno = null;
//
//        try {
//            try {
//                dataObject = jsonEncode(data);
//                paymentData.updatePaymentDataWithStart(dataObject);
//            }catch (JSONException err){
//                Log.d(TAG + "startTransaction ERROR", err.toString());
//                return err.toString();
//            }
//
//            Log.d(TAG, "----------     INÍCIO DA TRANSAÇÃO     ----------");
//            String restricoes = "{DevolveStringQRCode=1}";
//            int sts = sitef.startTransaction(
//                    this, paymentData.getPaymentType(), paymentData.getPaymentValue(),
//                    paymentData.getPaymentInvoice(), paymentData.getPaymentDate(),
//                    paymentData.getPaymentHour(), paymentData.getPaymentOperator(),
//                    restricoes
//            );
//
//            if (sts != 10000) {
//                retorno = "Inicia - ERRO: " + new ErrorMessages().getErrorMessageFromStatus(sts);
//                Log.d(TAG, retorno);
//            } else {
//                retorno = "Inicia - OK";
//                Log.d(TAG, retorno);
//            }
//
//        } catch (Exception err) {
//            retorno = err.toString();
//            Log.d(TAG + "startTransaction ERROR", retorno);
//        }
//
//        return TAG + retorno;
//    }
//
//    @JavascriptInterface
//    public void continueProcess(String buffer) {
//        Log.d(TAG, "CARAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACA");
//        int what = sitef.continueTransaction(buffer);
//        Log.d(TAG, String.valueOf(what));
//        Log.d(TAG, sitef.getBuffer());
//    }
//}


//
//package com.odhen.taa;
//
//        import android.app.Activity;
//        import android.os.Bundle;
//        import android.util.Log;
//        import android.webkit.JavascriptInterface;
//        import android.content.Context;
//
//        import org.json.JSONException;
//        import org.json.JSONObject;
//
//        import br.com.softwareexpress.sitef.android.CliSiTef;
//        import br.com.softwareexpress.sitef.android.CliSiTefI;
//        import br.com.softwareexpress.sitef.android.ICliSiTefListener;
//
//        import android.webkit.WebView;
//        import android.widget.Toast;
//
//public class SitefIntegration extends Activity implements ICliSiTefListener {
//    Context mContext;
//    private String TAG = "|SitefIntegration| ";
//    private CliSiTef sitef;
//    private SitefIntegration me;
//    private WebView webView;
//
//    protected PaymentData paymentData;
//    private JSONObject dataObject = null;
//    private JSONObject returnObject = null;
//    private String givenCommands = "";
//
//    /** Instantiate the interface and set the context */
//    SitefIntegration(Context c) {
//        mContext = c;
//    }
//
//    @JavascriptInterface
//    public void showToast(String message) {
//        Toast.makeText(mContext, message, Toast.LENGTH_SHORT).show();
//    }
//
//    @Override
//    protected void onCreate(Bundle savedInstanceState) {
//        Log.d(TAG, "onCreateeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeee");
//        super.onCreate(savedInstanceState);
//        setContentView(R.layout.activity_main);
//        webView = (WebView) findViewById(R.id.taaWebView);
//    }
//
//    private JSONObject jsonEncode(String data) throws JSONException {
//        return new JSONObject(data);
//    }
//
//    private void initSitefInstanceAndMe() {
//        Log.d(TAG, "----------     INICIA INSTANCIA DA SITEF     ----------");
//        sitef = new CliSiTef(mContext.getApplicationContext());
//        sitef.setActivity((Activity) mContext);
//        me = this;
//    }
//
//    private void closeSitefInstanceAndMe() {
//        Log.d(TAG, "----------     Encerra INSTANCIA DA SITEF     ----------");
//        if(sitef != null){
//            sitef.setActivity(null);
//        }
//        sitef = null;
//        me = null;
//    }
//
//    @Override
//    public void onData(int stage, int command, int fieldId, int minLength, int maxLength, byte [] input) {
//        Log.d(TAG, "ONDATAAAAAAAAAAAAAAAAAAAAAAAAA");
//        try {
//            boolean hasToContinue = me.identifyCommand(command, minLength, maxLength);
//
//            Log.d(TAG, "onData - estagio atual: "  + stage + ", comando: " + command + ", tipoCampo: " + fieldId + ", continua? " + hasToContinue + ".");
//            if(hasToContinue) {
//                sitef.continueTransaction(sitef.getBuffer());
//            }
//
//        } catch (Exception e) {
//            Log.d(TAG, e.getMessage().toString());
//            sitef.abortTransaction(0);
//        }
//    }
//
//    @Override
//    public void onTransactionResult(int currentStage, int resultCode) {
//        Log.d(TAG, "estagio atual: " + currentStage + ", resultado: " + resultCode);
//    }
//
//    @JavascriptInterface
//    public String configure (String data) {
//        String retorno = null;
//        try {
//            dataObject = jsonEncode(data);
//            this.paymentData = new PaymentData(dataObject);
//
//            returnObject = new JSONObject();
//            returnObject.put("error", true);
//            returnObject.put("message", "");
//            returnObject.put("errorCode", null);
//
//            initSitefInstanceAndMe();
//
//            Log.d(TAG, "----------     INÍCIO CONFIGURAÇÃO PARA TRANSAÇÃO     ---------- " +  paymentData.getPaymentIp() +" "+ paymentData.getPaymentStore() +" "+ paymentData.getPaymentTerminal() +" "+ paymentData.getParams());
//            int sts = sitef.configure(paymentData.getPaymentIp(), paymentData.getPaymentStore(), paymentData.getPaymentTerminal(), paymentData.getParams());
//
//            if(sts == 0) {
//                retorno = "Configura - OK";
//                Log.d(TAG, retorno);
//                return TAG + retorno;
//            } else {
//                retorno = new ErrorMessages().getErrorMessageFromStatus(sts);
//                Log.d(TAG, "Configura - ERRO: " + retorno);
//                return TAG + "Configura - ERRO: " + retorno;
//            }
//
//        }catch (JSONException err){
//            Log.d(TAG + "ConfigureError", err.toString());
//            return err.toString();
//        }
//    }
//
//    @JavascriptInterface
//    public String startTransaction (String data) {
//        String retorno = null;
//
//        try {
//            try {
//                dataObject = jsonEncode(data);
//                paymentData.updatePaymentDataWithStart(dataObject);
//            }catch (JSONException err){
//                Log.d(TAG + "startTransaction ERROR", err.toString());
//                return err.toString();
//            }
//
//            Log.d(TAG, "----------     INÍCIO DA TRANSAÇÃO     ----------");
//            String restricoes = "{DevolveStringQRCode=1}";
//            int sts = sitef.startTransaction(
//                    this, paymentData.getPaymentType(), paymentData.getPaymentValue(),
//                    paymentData.getPaymentInvoice(), paymentData.getPaymentDate(),
//                    paymentData.getPaymentHour(), paymentData.getPaymentOperator(),
//                    restricoes
//            );
//
//            if (sts != 10000) {
//                retorno = "Inicia - ERRO: " + new ErrorMessages().getErrorMessageFromStatus(sts);
//                Log.d(TAG, retorno);
//            } else {
//                retorno = "Inicia - OK";
//                Log.d(TAG, retorno);
//            }
//
//        } catch (Exception err) {
//            retorno = err.toString();
//            Log.d(TAG + "startTransaction ERROR", retorno);
//        }
//
//        return TAG + retorno;
//    }
//
//    @JavascriptInterface
//    public void continueProcess(String buffer) {
//        Log.d(TAG, "continueProcessSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS");
//        int what = sitef.continueTransaction(buffer);
//        Log.d(TAG, String.valueOf(what));
//        Log.d(TAG, sitef.getBuffer());
//    }
//
//
//    private boolean identifyCommand(int command, int minLength, int maxLength) throws JSONException {
//        String buffer = sitef.getBuffer();
//        returnObject.put("message", buffer);
//        int tipoCampo = sitef.getFieldId();
//        Log.d(TAG, "Buffer: " + buffer);
//
//        givenCommands += command + ", ";
//
//        if(buffer.contains("Insira") || buffer.contains("passe")) {
//            // webView.loadUrl("javascript:showCancelButton()");
//        }
//
//        switch (command) {
//            case CliSiTef.CMD_SHOW_QRCODE_FIELD:
//                switch (tipoCampo) {
//                    case 584:
//                        // webView.loadUrl("javascript:showQrCode('"+buffer+"')");
//                        break;
//                }
//                return true;
//            case CliSiTef.CMD_REMOVE_QRCODE_FIELD:
//                // webView.loadUrl("javascript:hideQrCode()");
//                return true;
//            case CliSiTefI.CMD_TITULO_MENU:
//                // webView.loadUrl("javascript:setLabel('" + buffer + "')");
//                return true;
//            case CliSiTefI.CMD_REMOVE_CABECALHO:
//                // webView.loadUrl("javascript:setLabel('SiTEF')");
//                return true;
//            case CliSiTefI.CMD_MENSAGEM:
//                // webView.loadUrl("javascript:setMessage('" + buffer + "')");
//                return true;
//            case CliSiTefI.CMD_REMOVE_MENSAGEM:
//                // webView.loadUrl("javascript:setMessage('')");
//                return true;
//            case CliSiTefI.CMD_RETORNO_VALOR:
//                switch (tipoCampo) {
//                    case 105:
//                        dataObject.put("transactionDate", buffer);
//                        break;
//                    case 121:
//                        dataObject.put("customerReceipt", buffer);
//                        break;
//                    case 122:
//                        dataObject.put("merchantReceipt", buffer);
//                        break;
//                    case 132:
//                        dataObject.put("cardBrandName", buffer);
//                        break;
//                    case 134:
//                        dataObject.put("uniqueSequentialNumber", buffer);
//                        break;
//                    case 136:
//                        dataObject.put("binCard", buffer);
//                        // webView.loadUrl("javascript:hideUserInterfaces()");
//                        break;
//                    case 1190:
//                        dataObject.put("lastNumbersCard", buffer);
//                        break;
//                    default:
//                        break;
//                }
//
//                return true;
//            case CliSiTefI.CMD_PERGUNTA_SE_INTERROMPE:
//                sitef.setBuffer("0");
//                return true;
//            case CliSiTefI.CMD_CONFIRMA_CANCELA:
//                sitef.setBuffer("0");
//                return true;
//            case CliSiTefI.CMD_SELECIONA_MENU:
//                validaTipoCampo(tipoCampo, maxLength, minLength, buffer);
//                return true;
//            case CliSiTefI.CMD_OBTEM_VALOR:
//                validaTipoCampo(tipoCampo, maxLength, minLength, buffer);
//                return true;
//            case CliSiTefI.CMD_OBTEM_QUALQUER_TECLA:
//            case CliSiTefI.CMD_OBTEM_CAMPO:
//                validaTipoCampo(tipoCampo, maxLength, minLength, buffer);
//                return true;
//            case CliSiTefI.CMD_MENSAGEM_OPERADOR:
//            case CliSiTefI.CMD_MENSAGEM_CLIENTE:
//            case CliSiTefI.CMD_REMOVE_MENSAGEM_OPERADOR:
//            case CliSiTefI.CMD_REMOVE_MENSAGEM_CLIENTE:
//            case CliSiTefI.CMD_REMOVE_TITULO_MENU:
//            default:
//                break;
//        }
//        return true;
//    }
//
//    private boolean validaTipoCampo(int tipoCampo, int maxLength, int minLength, String buffer) {
//        if(tipoCampo == 146) {
//            sitef.setBuffer(paymentData.getPaymentValue());
//        } else if(tipoCampo == 500){
//            sitef.setBuffer("123456");
//        } else if(tipoCampo == 504 || tipoCampo == 130) {
//            sitef.setBuffer("0");
//        } else if(tipoCampo == 515) {
//            sitef.setBuffer(paymentData.getPaymentDate());
//        } else if(tipoCampo == 516) {
//            String paymentNSU = paymentData.getPaymentNSU();
//
//            while(paymentNSU.length() > maxLength) { paymentNSU = paymentNSU.substring(1); }
//
//            sitef.setBuffer(paymentNSU);
//        } else if(tipoCampo == -1) {
//                    /* Validação para verificar se o tipoCampo -1 está sendo acessado para trazer as
//                     carteiras digitais que vem no formato 1:(nome da carteira digital);2:(nome da carteira);etc....*/
//            if (buffer.indexOf("1:") != -1) {
//                // webView.loadUrl("javascript:showMenuDigitalCard('" + buffer + "')");
//                return false;
//            } else {
//                // webView.loadUrl("javascript:hideUserInterfaces()");
//            }
//        } else {
//            // webView.loadUrl("javascript:promptCommand('" + buffer + "', " + minLength + ", " + maxLength + ", " + tipoCampo + ")");
//            return false;
//        }
//        return false;
//    }
//}
